# Copilot Instructions

- This project uses Django 5.1 as the web framework.
- Use Python 3.12 or above for all examples and code snippets.
- We use uv for dependency management, so all examples and code snippets should use uv.
- Include type hints in all Python code examples and explanations.
- Organize Python code in accordance with Django conventions, and prefer modern Python features when applicable.
- Assume that the reader has a advanced understanding of Python and Django.
- Dark mode is preferred for design-related examples or suggestions.
- Bootstrap 5 is the preferred CSS framework for design-related examples or suggestions.
- Use try-except blocks for error handling in all Python code examples.
- Add logging to all Python code examples.
- Write docstrings for all Python functions and classes.
- Prefetch related objects in Django ORM queries.
- Use database indexes in Django models. Our database is PostgreSQL 17.
